import 'package:flutter/cupertino.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_user_full_info.dart';
import 'package:tim_ui_kit_calling_plugin/enum/tim_uikit_trtc_call_conv_type.dart';
import 'package:tim_ui_kit_calling_plugin/enum/tim_uikit_trtc_calling_scence.dart';
import 'package:tim_ui_kit_calling_plugin/view/c2c/tim_uikit_trtc_c2c_calling.dart';

import 'package:tim_ui_kit_calling_plugin/view/group/tim_uikit_group_call.dart';

class TIMUIKitTRTC extends StatefulWidget {
  final bool isInitiationCalling;
  final ConvType convType;
  final V2TimUserFullInfo inviterUserInfo;
  final List<V2TimUserFullInfo> inviteUsersInfoList;
  final CallingScenes callScenes;
  final String? groupID;

  const TIMUIKitTRTC({
    // 判断群组通话还是c2c通话
    required this.convType,
    // 邀请人信息
    required this.inviterUserInfo,
    // 被邀请人信息,c2c情况下 只取第一个
    required this.inviteUsersInfoList,

    /// 语音通话 :CallingScenes.Audio
    /// 视频通话:CallingScenes.Video
    required this.callScenes,
    // 是否主动发起通话
    required this.isInitiationCalling,
    this.groupID,
    Key? key,
  }) : super(key: key);

  @override
  State<StatefulWidget> createState() => TIMUIKitTRTCState();
}

class TIMUIKitTRTCState extends State<TIMUIKitTRTC> {
  @override
  Widget build(BuildContext context) {
    return widget.convType == ConvType.c2c
        ? TIMUIKitTRTCc2cCalling(
            convType: widget.convType,
            inviteUsersInfoList: widget.inviteUsersInfoList,
            inviterUserInfo: widget.inviterUserInfo,
            callScenes: widget.callScenes,
            isInitiationCalling: widget.isInitiationCalling,
          )
        : TIMUIKitGroupCalling(
            convType: widget.convType,
            inviteUsersInfoList: widget.inviteUsersInfoList,
            inviterUserInfo: widget.inviterUserInfo,
            callScenes: widget.callScenes,
            isInitiationCalling: widget.isInitiationCalling,
            groupID: widget.groupID,
          );
  }
}
